﻿
#region Using Statements
using System;
using System.ComponentModel;
#endregion

namespace GridRowDelete.Data
{
    public class TopMovie : INotifyPropertyChanged
    {
        #region Private Members
        private string m_Title;
        private string m_RunningTime;
        private DateTime m_ReleaseDate;
        private string m_MPAARating;
        private string m_CriticsRating;
        private decimal m_CumGross;
        //private ChangeStatus m_Dirty;
        #endregion

        #region Constructors
        public TopMovie()
        {
            //m_Dirty = ChangeStatus.NoChange;
        }

        public TopMovie(string title,
                        string runningTime,
                        DateTime releaseDate,
                        string mpaaRating,
                        string criticsRating,
                        decimal cumGross)
        {
            Title = title;
            RunningTime = runningTime;
            ReleaseDate = releaseDate;
            MPAARating = mpaaRating;
            CriticsRating = criticsRating;
            CumGross = cumGross;
            //m_Dirty = ChangeStatus.NoChange;
        }

        public TopMovie(TopMovie item)
        {
            m_Title = item.Title;
            m_RunningTime = item.RunningTime;
            m_ReleaseDate = item.ReleaseDate;
            m_MPAARating = item.MPAARating;
            m_CriticsRating = item.CriticsRating;
            m_CumGross = item.CumGross;
            //m_Dirty = item.Dirty;
        }
        #endregion

        #region Properties
        public string Title
        {
            get { return m_Title; }
            set
            {
                m_Title = value;
                this.OnPropertyChanged("Title");
            }
        }

        public string RunningTime
        {
            get { return m_RunningTime; }
            set
            {
                m_RunningTime = value;
                this.OnPropertyChanged("RunningTime");
            }
        }

        public DateTime ReleaseDate
        {
            get { return m_ReleaseDate; }
            set
            {
                m_ReleaseDate = value;
                this.OnPropertyChanged("ReleaseDate");
            }
        }

        public string MPAARating
        {
            get { return m_MPAARating; }
            set
            {
                m_MPAARating = value;
                this.OnPropertyChanged("MPAARating");
            }
        }

        public string CriticsRating
        {
            get { return m_CriticsRating; }
            set
            {
                m_CriticsRating = value;
                this.OnPropertyChanged("CriticsRating");
            }
        }

        public decimal CumGross
        {
            get { return m_CumGross; }
            set
            {
                m_CumGross = value;
                this.OnPropertyChanged("CumGross");
            }
        }

                                                //public ChangeStatus Dirty
                                                //{
                                                //    get { return m_Dirty; }
                                                //    set
                                                //    {
                                                //        m_Dirty = value;
                                                //        this.OnPropertyChanged("Dirty");
                                                //    }
                                                //}
        #endregion

        #region INotifyPropertyChanged Members
        public event PropertyChangedEventHandler PropertyChanged;
        void OnPropertyChanged(string prop)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(prop));
            }
        }
        #endregion
    }
}
